//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  DarkGray
#property indicator_color4  DeepSkyBlue
#property indicator_color5  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_style5  STYLE_DOT

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame = PERIOD_CURRENT;
extern int                FastEma1 = 12;
extern int                SlowEma1 = 26;
extern ENUM_APPLIED_PRICE Price1   = PRICE_CLOSE;
extern int                FastEma2 = 24;
extern int                SlowEma2 = 52;
extern ENUM_APPLIED_PRICE Price2   = PRICE_CLOSE;
extern int                FastEma3 = 0;
extern int                SlowEma3 = 0;
extern ENUM_APPLIED_PRICE Price3   = PRICE_CLOSE;
extern int                FastEma4 = 0;
extern int                SlowEma4 = 0;
extern ENUM_APPLIED_PRICE Price4   = PRICE_CLOSE;
extern int                FastEma5 = 0;
extern int                SlowEma5 = 0;
extern ENUM_APPLIED_PRICE Price5   = PRICE_CLOSE;
extern int                FastEma6 = 0;
extern int                SlowEma6 = 0;
extern ENUM_APPLIED_PRICE Price6   = PRICE_CLOSE;
extern int                FastEma7 = 0;
extern int                SlowEma7 = 0;
extern ENUM_APPLIED_PRICE Price7   = PRICE_CLOSE;
extern int                FastEma8 = 0;
extern int                SlowEma8 = 0;
extern ENUM_APPLIED_PRICE Price8   = PRICE_CLOSE;
extern int                SignalPeriod = 9;
extern ENUM_MA_METHOD     SignalMaMode = MODE_EMA;
extern bool               LinesVisible = false;
extern string             LinesID      = "CompMACD1";
extern color              LinesUpColor = LimeGreen;
extern color              LinesDnColor = OrangeRed;
extern int                LinesStyle   = STYLE_SOLID;
extern int                LinesWidth   = 0;
extern bool               Interpolate  = true;

double macd[];
double hist[];
double histu[];
double histd[];
double sign[];
double cross[];
string shortName;
string indicatorFileName;
bool   returnBars;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,histu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,hist);
   SetIndexBuffer(3,macd);
   SetIndexBuffer(4,sign);
   SetIndexBuffer(5,cross);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99; if (returnBars) { return(0); }
         TimeFrame         = MathMax(TimeFrame,_Period);
         shortName         = LinesID+" MACD - composite";
   IndicatorShortName(shortName);
   return(0);
}
int deinit()
{
   string find = LinesID+":";
   for (int i=ObjectsTotal()-1; i>= 0; i--)
   {
      string name = ObjectName(i); if (StringFind(name,find)==0) ObjectDelete(name);
   }
   return(0); 
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { histu[0] = limit+1; return(0); }
            int window = WindowFind(shortName);

   //
   //
   //
   //
   //
   
   if (TimeFrame==_Period)
   {
    	for(int i = limit; i>=0; i--)
 	   {  
 	      double div=0;
 	      macd[i] = 0;
 	      if (FastEma1>0 && SlowEma1>0) { macd[i] += iMACD(NULL,0,FastEma1,SlowEma1,1,Price1,MODE_MAIN,i); div++; }
 	      if (FastEma2>0 && SlowEma2>0) { macd[i] += iMACD(NULL,0,FastEma2,SlowEma2,1,Price2,MODE_MAIN,i); div++; }
 	      if (FastEma3>0 && SlowEma3>0) { macd[i] += iMACD(NULL,0,FastEma3,SlowEma3,1,Price3,MODE_MAIN,i); div++; }
 	      if (FastEma4>0 && SlowEma4>0) { macd[i] += iMACD(NULL,0,FastEma4,SlowEma4,1,Price4,MODE_MAIN,i); div++; }
 	      if (FastEma5>0 && SlowEma5>0) { macd[i] += iMACD(NULL,0,FastEma5,SlowEma5,1,Price5,MODE_MAIN,i); div++; }
 	      if (FastEma6>0 && SlowEma6>0) { macd[i] += iMACD(NULL,0,FastEma6,SlowEma6,1,Price6,MODE_MAIN,i); div++; }
 	      if (FastEma7>0 && SlowEma7>0) { macd[i] += iMACD(NULL,0,FastEma7,SlowEma7,1,Price7,MODE_MAIN,i); div++; }
 	      if (FastEma8>0 && SlowEma8>0) { macd[i] += iMACD(NULL,0,SlowEma8,SlowEma8,1,Price8,MODE_MAIN,i); div++; }
 	      if (div>0) macd[i] /= div;
      } 	    
 	   for(i = limit; i>=0; i--)
 	   {
 	      sign[i]  = iMAOnArray(macd,0,SignalPeriod,0,SignalMaMode,i);
 	      hist[i]  = macd[i]-sign[i];
 	      histu[i] = EMPTY_VALUE;
 	      histd[i] = EMPTY_VALUE;
 	      cross[i] = cross[i+1];
 	         if (hist[i]>0) { histu[i] = hist[i]; cross[i]= 1; }
 	         if (hist[i]<0) { histd[i] = hist[i]; cross[i]=-1; }
 	         if (LinesVisible && window>-1)
 	         {
 	            string name = LinesID+":"+Time[i];
 	               ObjectDelete(name);
 	               if (cross[i]!=cross[i+1])
 	               {
 	                  color theColor  = LinesUpColor; if (cross[i]==-1) theColor = LinesDnColor;
 	                     ObjectCreate(name,OBJ_VLINE,window,Time[i],0);
 	                        ObjectSet(name,OBJPROP_WIDTH,LinesWidth);
 	                        ObjectSet(name,OBJPROP_STYLE,LinesStyle);
 	                        ObjectSet(name,OBJPROP_COLOR,theColor);
 	               }
 	         }
 	   }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y    = iBarShift(NULL,TimeFrame,Time[i]);
      histu[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastEma1,SlowEma1,Price1,FastEma2,SlowEma2,Price2,FastEma3,SlowEma3,Price3,FastEma4,SlowEma4,Price4,FastEma5,SlowEma5,Price5,FastEma6,SlowEma6,Price6,FastEma7,SlowEma7,Price7,FastEma8,SlowEma8,Price8,SignalPeriod,SignalMaMode,LinesVisible,LinesID,LinesUpColor,LinesDnColor,LinesStyle,LinesWidth,0,y);
      histd[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastEma1,SlowEma1,Price1,FastEma2,SlowEma2,Price2,FastEma3,SlowEma3,Price3,FastEma4,SlowEma4,Price4,FastEma5,SlowEma5,Price5,FastEma6,SlowEma6,Price6,FastEma7,SlowEma7,Price7,FastEma8,SlowEma8,Price8,SignalPeriod,SignalMaMode,LinesVisible,LinesID,LinesUpColor,LinesDnColor,LinesStyle,LinesWidth,1,y);
      hist[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastEma1,SlowEma1,Price1,FastEma2,SlowEma2,Price2,FastEma3,SlowEma3,Price3,FastEma4,SlowEma4,Price4,FastEma5,SlowEma5,Price5,FastEma6,SlowEma6,Price6,FastEma7,SlowEma7,Price7,FastEma8,SlowEma8,Price8,SignalPeriod,SignalMaMode,LinesVisible,LinesID,LinesUpColor,LinesDnColor,LinesStyle,LinesWidth,2,y);
      macd[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastEma1,SlowEma1,Price1,FastEma2,SlowEma2,Price2,FastEma3,SlowEma3,Price3,FastEma4,SlowEma4,Price4,FastEma5,SlowEma5,Price5,FastEma6,SlowEma6,Price6,FastEma7,SlowEma7,Price7,FastEma8,SlowEma8,Price8,SignalPeriod,SignalMaMode,LinesVisible,LinesID,LinesUpColor,LinesDnColor,LinesStyle,LinesWidth,3,y);
      sign[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastEma1,SlowEma1,Price1,FastEma2,SlowEma2,Price2,FastEma3,SlowEma3,Price3,FastEma4,SlowEma4,Price4,FastEma5,SlowEma5,Price5,FastEma6,SlowEma6,Price6,FastEma7,SlowEma7,Price7,FastEma8,SlowEma8,Price8,SignalPeriod,SignalMaMode,LinesVisible,LinesID,LinesUpColor,LinesDnColor,LinesStyle,LinesWidth,4,y);

      //
      //
      //
      //
      //
      
      if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;
         
         //
         //
         //
         //
         //
         
         datetime time = iTime(NULL,TimeFrame,y);
         for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	double factor = 1.0 / n;
         for(int j = 1; j < n; j++)
         {
     	      hist[i+j] = j*factor*hist[i+n] + (1.0-j*factor)*hist[i];
     	      macd[i+j] = j*factor*macd[i+n] + (1.0-j*factor)*macd[i];
     	      sign[i+j] = j*factor*sign[i+n] + (1.0-j*factor)*sign[i];
     	      if (histu[i] != EMPTY_VALUE) histu[i+j] = hist[i+j];
     	      if (histd[i] != EMPTY_VALUE) histd[i+j] = hist[i+j];
        }  	            
   }
   return(0);         
}